'use strict';

var  pmongo = require('promised-mongo')
   , crypto = require('crypto')
	 , mongolib = require('../castor-core/lib/mongo.js')
;

module.exports = function(options,config) {
	
	config = config.get();
	options = options || {};
	options.toKeep = options.toKeep ? options.toKeep : null;
	options.connexionURI = options.connexionURI || 'mongodb://localhost:27017/test/';

	return function (input, submit) {

		var db = mongolib.connect(config.connexionURI);	
		config.collectionName = config.collectionName ||  crypto.createHash('sha1').update(input.basedir).digest('hex');

		var coll = db.collection(config.collectionName);

		if(!options.toKeep){
			return submit(null, input);
		}
		coll.findOne({ fid : input.fid }).then(function(doc){
			if(!doc){
				return submit(null , input);
			}
			if(options.toKeep instanceof Array){
				for (var i = 0; i < options.toKeep.length; i++) {
					if (doc[options.toKeep[i]]) {
						input[options.toKeep[i]] = doc[options.toKeep[i]];
					};
				};
			}
			else if( typeof(options.toKeep) === "string" ){
				if (doc[options.toKeep[i]]) {
						input[options.toKeep[i]] = doc[options.toKeep[i]];
				};
			}
			submit(null, input);
		}).catch(function(err){
			console.error("Error : ", err);
			submit(err, input);
		});
	};
	db.close();
}
